SystemOrganization addCategory: #'DiffEng-Tests'!
SystemOrganization addCategory: #'DiffEng-Bogus'!
SystemOrganization addCategory: #'DiffEng-Graph'!
SystemOrganization addCategory: #'DiffEng-Annotation'!
SystemOrganization addCategory: #'DiffEng-Patches'!

Object subclass: #DEEdge
	instanceVariableNames: 'graph source target annotation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Graph'!

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/24/2004 11:04'!
matchFor: aBlossom
	aBlossom = source ifTrue: [^ target].
	aBlossom = target ifTrue: [^ source].
	^ nil! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/23/2004 09:45'!
graph: anObject
	graph := anObject.
	source graph: anObject.
	target graph: anObject! !

!DEEdge methodsFor: 'testing' stamp: 'cwp 6/21/2004 16:33'!
isCreation
	^ source isCreation! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/23/2004 09:42'!
graph
	^graph! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/21/2004 11:26'!
target: anObject
	target := anObject.
	target addEdge: self! !

!DEEdge methodsFor: 'testing' stamp: 'cwp 6/23/2004 11:18'!
hasAnnotation
	^ annotation notNil! !

!DEEdge methodsFor: 'testing' stamp: 'cwp 6/26/2004 15:43'!
isSimple
	^ self isCreation or: [self isDestruction] or: [self isPair]! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/22/2004 13:57'!
op: aSymbol
	self annotation operation: aSymbol! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/23/2004 09:33'!
petal
	source isPetal ifTrue: [^ source].
	target isPetal ifTrue: [^ target].
	^ nil! !

!DEEdge methodsFor: 'testing' stamp: 'cwp 6/23/2004 11:12'!
parentsAreConnected
	^ graph parentsAreConnected: self! !

!DEEdge class methodsFor: 'instance creation' stamp: 'cwp 6/20/2004 00:39'!
source: aBlossom1 target: aBlossom2 
	^ self new source: aBlossom1; target: aBlossom2! !

!DEEdge methodsFor: 'testing' stamp: 'cwp 6/23/2004 10:21'!
parentsMatch
	^ graph parentsMatch: self! !

!DEEdge methodsFor: 'testing' stamp: 'cwp 6/21/2004 16:44'!
isDestruction
	^ target isDestruction! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/29/2004 13:57'!
annotation: anObject 
	annotation _ anObject! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/23/2004 09:33'!
stem
	source isStem ifTrue: [^ source].
	target isStem ifTrue: [^ target].
	^ nil! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/29/2004 13:52'!
annotation
	^ annotation ! !

!DEEdge methodsFor: 'releasing' stamp: 'cwp 6/22/2004 14:43'!
prune
	source removeEdge: self.
	target removeEdge: self! !

!DEEdge methodsFor: 'enumerating' stamp: 'cwp 6/21/2004 16:33'!
nodeBlossomsDo: aBlock
	source isCreation ifFalse: [aBlock value: source].
	target isDestruction ifFalse: [aBlock value: target]! !

!DEEdge methodsFor: 'enumerating' stamp: 'cwp 6/21/2004 18:47'!
blossomsDo: aBlockContext 
	aBlockContext value: source value: target! !

!DEEdge methodsFor: 'releasing' stamp: 'cwp 6/22/2004 14:43'!
pruneIfTrue: aBoolean 
	aBoolean ifTrue: [self prune].
	^aBoolean! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/20/2004 00:03'!
source
	^source! !

!DEEdge methodsFor: 'printing' stamp: 'cwp 6/29/2004 13:59'!
printOn: stream
	stream nextPutAll: self class name.
	source printIdentityOn: stream.
	self hasAnnotation ifTrue: [self annotation printOn: stream].
	target printIdentityOn: stream.! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/20/2004 00:03'!
target
	^target! !

!DEEdge methodsFor: 'accessing' stamp: 'cwp 6/21/2004 11:26'!
source: anObject
	source := anObject.
	source addEdge: self! !

!DEEdge methodsFor: 'testing' stamp: 'cwp 6/21/2004 19:34'!
isPair
	^ source edges size = 1 and: [target edges size = 1]! !

Object subclass: #DEBogusNode
	instanceVariableNames: 'parent name label left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Bogus'!

!DEBogusNode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:16'!
addRight: aNode
	right ifNil: [right _ SortedCollection new].
	right add: aNode.
	aNode parent: self.
	^ aNode! !

!DEBogusNode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:16'!
parent: anObject
	parent := anObject! !

!DEBogusNode class methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2004 23:37'!
name: aSymbol label: aSymbol2 
	^ self new name: aSymbol; label: aSymbol2! !

!DEBogusNode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:12'!
label
	^label! !

!DEBogusNode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:13'!
left
	^ left ifNil: [#()]! !

!DEBogusNode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:16'!
parent
	^parent! !

!DEBogusNode methodsFor: 'testing' stamp: 'cwp 6/20/2004 00:10'!
couldMatch: aNode
	^ self class = aNode class! !

!DEBogusNode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:12'!
name: anObject
	name := anObject! !

!DEBogusNode class methodsFor: 'instance creation' stamp: 'cwp 6/22/2004 13:44'!
name: aSymbol 
	^ self new name: aSymbol! !

!DEBogusNode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:15'!
addLeft: aNode
	left ifNil: [left _ OrderedCollection new].
	left add: aNode.
	aNode parent: self.
	^ aNode! !

!DEBogusNode methodsFor: 'testing' stamp: 'cwp 6/21/2004 21:14'!
isBlossom
	^ false! !

!DEBogusNode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:12'!
name
	^name! !

!DEBogusNode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:12'!
label: anObject
	label := anObject! !

!DEBogusNode methodsFor: 'enumerating' stamp: 'cwp 6/20/2004 00:19'!
addAllNodesTo: aCollection
	aCollection add: self.
	self left do: [:ea | ea addAllNodesTo: aCollection].
	self right do: [:ea | ea addAllNodesTo: aCollection].
	^ aCollection! !

DEBogusNode subclass: #DEBogusNodeB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Bogus'!

!DEBogusNode methodsFor: 'printing' stamp: 'cwp 6/24/2004 11:10'!
printOn: aStream
	self class name printOn: aStream.
	aStream nextPut: $<.
	self name printOn: aStream.
	aStream nextPut: $>.! !

!DEBogusNode methodsFor: 'enumerating' stamp: 'cwp 6/23/2004 14:55'!
allNodes
	^ self addAllNodesTo: OrderedCollection new
! !

DEBogusNode subclass: #DEBogusNodeA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Bogus'!

!DEBogusNode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:13'!
right
	^ right ifNil: [#()]! !

Object subclass: #DEBogusGrammar
	instanceVariableNames: 'comparator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Bogus'!

!DEBogusGrammar methodsFor: 'accessing' stamp: 'cwp 6/24/2004 16:59'!
comparator
	^comparator! !

!DEBogusGrammar class methodsFor: 'as yet unclassified' stamp: 'cwp 6/24/2004 16:59'!
comparator: aBlock	
	^ self new comparator: aBlock! !

!DEBogusGrammar methodsFor: 'diffing' stamp: 'cwp 6/24/2004 17:00'!
could: sNode match: tNode
	^ comparator value: sNode value: tNode! !

!DEBogusGrammar methodsFor: 'accessing' stamp: 'cwp 6/24/2004 16:59'!
comparator: anObject
	comparator := anObject! !

!DEBogusGrammar methodsFor: 'diffing' stamp: 'cwp 6/24/2004 13:52'!
allNodesIn: aNode
	^ aNode allNodes! !

Object subclass: #DECopyFlower
	instanceVariableNames: 'governingNode edges hasExtraCopy distinguishedEdge freeCopies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Annotation'!

!DECopyFlower methodsFor: 'annotating' stamp: 'cwp 6/28/2004 14:35'!
chooseDistinguishedEdge
	^ distinguishedEdge := edges 
							detect: [:ea | ea annotation dependencies isEmpty]
							ifNone: [edges anyOne]! !

!DECopyFlower methodsFor: 'annotating' stamp: 'cwp 6/29/2004 14:00'!
annotate: edge with: op 
	| parent |
	edge annotation op: op.
	parent := edge petal effectiveParent.
	freeCopies keysAndValuesDo: 
			[:k :v | 
			k == parent ifFalse: [freeCopies at: k put: (freeCopies at: k) + 1].
			self dependencyBetween: k edge and: edge]! !

!DECopyFlower methodsFor: 'annotating' stamp: 'cwp 6/28/2004 12:03'!
governingNodeIsParent
	^governingNode = edges anyOne stem parent! !

!DECopyFlower methodsFor: 'annotating' stamp: 'cwp 6/28/2004 12:39'!
freeCopyFor: aNode 
	(freeCopies at: aNode effectiveParent) = 0
		ifTrue: [^ false]
		ifFalse: [freeCopies at: aNode parent put: (freeCopies at: aNode effectiveParent) - 1.
				^ true]! !

!DECopyFlower class methodsFor: 'instance creation' stamp: 'cwp 6/26/2004 19:40'!
withGoverningNode: aDENode 
	^ self new setGoverningNode: aDENode! !

!DECopyFlower methodsFor: 'testing' stamp: 'cwp 6/28/2004 14:30'!
isSource
	^ edges anyOne source isStem! !

!DECopyFlower methodsFor: 'accessing' stamp: 'cwp 6/26/2004 15:37'!
hasExtraCopy
	^ hasExtraCopy ifNil: [^ false]! !

!DECopyFlower methodsFor: 'annotating' stamp: 'cwp 6/29/2004 14:00'!
annotate
	self annotateDistinguishedEdge.
	edges do: 
			[:ea | 
			(self freeCopyFor: ea petal) 
				ifTrue: [ea annotation op: #noOp]
				ifFalse: [self annotate: ea with: self op]]
		without: distinguishedEdge! !

!DECopyFlower methodsFor: 'accessing' stamp: 'cwp 6/26/2004 15:57'!
addEdge: anEdge 
	edges ifNil: [edges _ Set new].
	edges add: anEdge! !

!DECopyFlower methodsFor: 'annotating' stamp: 'cwp 6/28/2004 12:56'!
annotateDistinguishedEdge
	| op |
	self chooseDistinguishedEdge.
	op := self governingNodeIsParent 
				ifTrue: [#noOp]
				ifFalse: [self hasExtraCopy ifTrue: [#move] ifFalse: [self op]].
	self annotate: distinguishedEdge with: op! !

!DECopyFlower methodsFor: 'accessing' stamp: 'cwp 6/28/2004 14:30'!
op
	^ self isSource ifTrue: [#copy] ifFalse: [#join]! !

!DECopyFlower methodsFor: 'accessing' stamp: 'cwp 6/26/2004 15:37'!
useExtraCopy
	hasExtraCopy _ true! !

!DECopyFlower methodsFor: 'accessing' stamp: 'cwp 6/26/2004 19:40'!
governingNode
	^ governingNode! !

!DECopyFlower methodsFor: 'testing' stamp: 'cwp 6/28/2004 14:30'!
isTarget
	^ edges anyOne target isStem! !

!DECopyFlower methodsFor: 'initialize-release' stamp: 'cwp 6/28/2004 12:33'!
setGoverningNode: aNode
	governingNode _ aNode.
	edges _ Set new.
	hasExtraCopy _ false.
	freeCopies _ Dictionary new.
	governingNode matchedNodes do: [:ea | freeCopies at: ea put: 0].! !

!DECopyFlower methodsFor: 'annotating' stamp: 'cwp 6/28/2004 16:25'!
dependencyBetween: governingEdge and: flowerEdge
	self isSource
		ifTrue: [governingEdge annotation addDependency: flowerEdge]
		ifFalse: [flowerEdge annotation addDependency: governingEdge]! !

Object subclass: #DEAnnotator
	instanceVariableNames: 'graph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Annotation'!

!DEAnnotator methodsFor: 'flowers' stamp: 'cwp 6/28/2004 16:41'!
annotateFlowers
	| annotateStems |
	annotateStems _ [:ea | ea isStem ifTrue: [self annotateFlower: ea]].
	graph source do: annotateStems.
	graph target do: annotateStems! !

!DEAnnotator methodsFor: 'accessing' stamp: 'cwp 6/24/2004 16:43'!
graph: anObject
	graph := anObject! !

!DEAnnotator methodsFor: 'flowers' stamp: 'cwp 6/28/2004 16:40'!
annotateFlower: stem 
	| copyFlowers extraCopies |
	copyFlowers := self partitionPetals: stem.
	extraCopies := self extraCopiesFor: stem.
	copyFlowers _ copyFlowers asSortedCollection: [:a :b | a size <= b size].
	(copyFlowers first: extraCopies) do: [:ea | ea useExtraCopy].
	copyFlowers do: [:ea | ea annotate]! !

!DEAnnotator methodsFor: 'flowers' stamp: 'cwp 6/28/2004 16:41'!
partitionPetals: stem
	| flowers gNode |
	flowers _ IdentitySet new.
	stem edges do: [:ea |
					gNode _ self governingNodeFor: ea petal.
					(flowers 
						detect: [:flower | flower governingNode = gNode]
						ifNone: [flowers add: (DECopyFlower withGoverningNode: gNode)])
							addEdge: ea].
	^ flowers! !

!DEAnnotator methodsFor: 'accessing' stamp: 'cwp 6/24/2004 16:43'!
graph
	^graph! !

!DEAnnotator methodsFor: 'simple edges' stamp: 'cwp 6/29/2004 13:55'!
annotateEdge: edge 
	edge isCreation ifTrue: [^ self insert: edge].
	edge isDestruction ifTrue: [^ self delete: edge].
	self move: edge! !

!DEAnnotator methodsFor: 'flowers' stamp: 'cwp 6/28/2004 16:40'!
extraCopiesFor: stem 
	| petalParents |
	petalParents _ stem edges collect: [:ea | ea petal parent].
	^ (stem parent matchedNodes asSet
		removeAllSuchThat: [:ea | petalParents includes: ea]) size! !

!DEAnnotator class methodsFor: 'as yet unclassified' stamp: 'cwp 6/21/2004 12:53'!
annotate: aGraph 
	^ (self forGraph: aGraph) annotate! !

!DEAnnotator methodsFor: 'annotating' stamp: 'cwp 6/29/2004 13:57'!
initializeAnnotations
	graph edges do: [:ea | ea annotation: DEOpAnnotation new]! !

!DEAnnotator methodsFor: 'flowers' stamp: 'cwp 6/28/2004 16:41'!
governingNodeFor: aPetal
	| node |
	node _ aPetal parent.
	[node matchedNodes first isCreation] whileTrue: [node _ node parent].
	^ node matchedNodes first! !

!DEAnnotator methodsFor: 'annotating' stamp: 'cwp 6/29/2004 13:56'!
annotate
	self initializeAnnotations.
	self annotateSimpleEdges.
	self annotateFlowers.! !

!DEAnnotator methodsFor: 'simple edges' stamp: 'cwp 6/28/2004 16:40'!
annotateSimpleEdges
	graph edges do: [:ea | ea isSimple ifTrue: [self annotateEdge: ea]]! !

!DEAnnotator methodsFor: 'simple edges' stamp: 'cwp 6/29/2004 14:19'!
insert: edge
	edge annotation op: #insert! !

!DEAnnotator methodsFor: 'simple edges' stamp: 'cwp 6/29/2004 13:58'!
move: edge
	edge source parent = edge target parent
		ifTrue: [edge annotation op: #noOp]
		ifFalse: [edge annotation op: #move]! !

!DEAnnotator class methodsFor: 'as yet unclassified' stamp: 'cwp 6/21/2004 12:53'!
forGraph: aBipartiteGraph
	^ self new graph: aBipartiteGraph! !

!DEAnnotator methodsFor: 'simple edges' stamp: 'cwp 6/29/2004 14:19'!
delete: edge
	edge annotation op: #delete! !

Object subclass: #DEBipartiteGraph
	instanceVariableNames: 'grammar source target creation destruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Graph'!

!DEBipartiteGraph methodsFor: 'accessing' stamp: 'cwp 6/24/2004 16:44'!
target
	^target! !

!DEBipartiteGraph class methodsFor: 'instance creation' stamp: 'cwp 6/24/2004 13:46'!
source: sourceTree target: targetTree grammar: grammar
	^ self new setGrammar: grammar source: sourceTree target: targetTree! !

!DEBipartiteGraph methodsFor: 'initializing' stamp: 'cwp 6/24/2004 14:12'!
wrapNodes: nodes
	| index wrappers wrapper |
	index _ IdentityDictionary new.
	wrappers _ Array new: nodes size.
	nodes withIndexDo: [:node :i | 
				wrapper _ DENode for: node.
				index at: node put: wrapper. 
				wrapper parent: (index at: node parent ifAbsent: []).
				wrappers at: i put: wrapper].
	^ wrappers! !

!DEBipartiteGraph methodsFor: 'initializing' stamp: 'cwp 6/24/2004 14:48'!
createEdges
	source do: [:ea | DEEdge source: ea target: destruction].
	target do: [:ea | DEEdge source: creation target: ea].
	source 
		with: target
		pairsDo: [:s :t | (grammar could: s node match: t node) 
						ifTrue: [DEEdge source: s target: t]].! !

!DEBipartiteGraph methodsFor: 'accessing' stamp: 'cwp 6/24/2004 13:57'!
edges
	| edges |
	edges _ Set new.
	source do: [:ea | edges addAll: ea edges].
	target do: [:ea | edges addAll: ea edges].
	^ edges! !

!DEBipartiteGraph methodsFor: 'accessing' stamp: 'cwp 6/24/2004 16:44'!
target: anObject
	target := anObject! !

!DEBipartiteGraph methodsFor: 'initializing' stamp: 'cwp 6/24/2004 14:26'!
setGrammar: aGrammar source: sourceRoot target: targetRoot 
	grammar := aGrammar.
	creation := DECreationNode new.
	destruction := DEDestructionNode new.
	source := self wrapNodes: (grammar allNodesIn: sourceRoot).
	target := self wrapNodes: (grammar allNodesIn: targetRoot).
	self createEdges! !

!DEBipartiteGraph methodsFor: 'accessing' stamp: 'cwp 6/24/2004 16:44'!
source
	^source! !

!DEBipartiteGraph methodsFor: 'accessing' stamp: 'cwp 6/24/2004 16:44'!
source: anObject
	source := anObject! !

Object subclass: #DEOpAnnotation
	instanceVariableNames: 'operation dependencies updates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Annotation'!

!DEOpAnnotation methodsFor: 'accessing' stamp: 'cwp 6/22/2004 13:56'!
operation
	^operation! !

!DEOpAnnotation methodsFor: 'accessing' stamp: 'cwp 6/29/2004 14:11'!
op
	^ operation! !

!DEOpAnnotation methodsFor: 'accessing' stamp: 'cwp 6/29/2004 13:50'!
updates
	^updates ifNil: [Set new]! !

!DEOpAnnotation class methodsFor: 'as yet unclassified' stamp: 'cwp 6/22/2004 13:57'!
op: aStructuralOperation
	^ self new operation: aStructuralOperation! !

!DEOpAnnotation methodsFor: 'accessing' stamp: 'cwp 6/28/2004 14:31'!
dependencies
	^ dependencies ifNil: [#()]! !

!DEOpAnnotation methodsFor: 'accessing' stamp: 'cwp 6/29/2004 13:50'!
addUpdate: aSelector 
	updates ifNil: [updates := Set new].
	updates add: aSelector! !

!DEOpAnnotation class methodsFor: 'as yet unclassified' stamp: 'cwp 6/21/2004 12:40'!
noOp
	^ self op: #noOp! !

!DEOpAnnotation methodsFor: 'accessing' stamp: 'cwp 6/29/2004 14:14'!
op: aSymbol
	operation ifNotNil: [self error: 'This edge is already annotated'].
	operation _ aSymbol! !

!DEOpAnnotation methodsFor: 'accessing' stamp: 'cwp 6/28/2004 14:32'!
addDependency: anEdge
	dependencies ifNil: [dependencies _ Set new].
	dependencies add: anEdge! !

Object subclass: #DEAbstractNode
	instanceVariableNames: 'edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Graph'!

!DEAbstractNode methodsFor: 'accessing' stamp: 'cwp 6/20/2004 12:52'!
edges
	^ edges ifNil: [#()]! !

!DEAbstractNode methodsFor: 'accessing' stamp: 'cwp 6/26/2004 20:27'!
addEdge: anEdge
	edges ifNil: [edges _ Set new].
	edges add: anEdge! !

!DEAbstractNode methodsFor: 'testing' stamp: 'cwp 6/20/2004 13:02'!
hasNode
	^ false! !

!DEAbstractNode methodsFor: 'testing' stamp: 'cwp 6/20/2004 12:53'!
isDestruction
	^ false! !

!DEAbstractNode methodsFor: 'testing' stamp: 'cwp 6/20/2004 12:52'!
isCreation
	^ false! !

!DEAbstractNode methodsFor: 'accessing' stamp: 'cwp 6/26/2004 20:28'!
matchedNodes
	^ self isStem 
			ifTrue: [edges collect: [:ea | ea petal]]
			ifFalse: [Array with: (edges anyOne matchFor: self)]! !

!DEAbstractNode methodsFor: 'printing' stamp: 'cwp 6/24/2004 14:41'!
printIdentityOn: stream 
	stream nextPut: $<.
	self identityHash printOn: stream.
	stream nextPut: $-.
	self edges size printOn: stream.
	stream nextPut: $>! !

DEAbstractNode subclass: #DENode
	instanceVariableNames: 'parent node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Graph'!

!DENode methodsFor: 'testing' stamp: 'cwp 6/26/2004 18:18'!
isDescendantOf: aNode
	| cursor |
	cursor _ self.
	[cursor notNil and: [cursor ~~ aNode]] whileTrue: [cursor _ cursor parent].
	^ cursor notNil! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/28/2004 12:37'!
effectiveParent
	| cursor |
	cursor _ self parent.
	[cursor matchedNodes first isCreation] whileTrue: [cursor _ cursor parent].
	^ cursor! !

!DENode methodsFor: 'testing' stamp: 'cwp 6/24/2004 17:10'!
isCreated
	^ edges size = 1 and: [edges first isCreation]! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/19/2004 23:46'!
node: aNode
	node _ aNode! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/24/2004 14:15'!
parent: aNode 
	parent := aNode! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/28/2004 12:22'!
edge
	^ edges anyOne! !

!DENode methodsFor: 'testing' stamp: 'cwp 6/20/2004 13:02'!
hasNode
	^ true! !

!DENode methodsFor: 'testing' stamp: 'cwp 6/24/2004 16:46'!
isDestroyed
	^ edges size = 1 and: [edges first isDestruction]! !

!DENode class methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2004 23:46'!
for: aNode
	^ self new node: aNode! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/24/2004 17:06'!
parent
	^parent! !

!DENode methodsFor: 'testing' stamp: 'cwp 6/22/2004 14:23'!
couldMatch: aBlossom with: comparator
	^ aBlossom hasNode
		ifFalse: [true]
		ifTrue: [comparator value: self value: aBlossom]! !

!DENode methodsFor: 'accessing' stamp: 'cwp 6/20/2004 00:08'!
node
	^ node! !

DEAbstractNode subclass: #DECreationNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Graph'!

!DECreationNode methodsFor: 'testing' stamp: 'cwp 6/20/2004 12:52'!
isCreation
	^ true! !

!DECreationNode methodsFor: 'printing' stamp: 'cwp 6/24/2004 10:01'!
printIdentityOn: stream
	stream nextPut: $<.
	stream nextPut: $+.
	stream nextPut: $>! !

!DECreationNode methodsFor: 'testing' stamp: 'cwp 6/22/2004 14:20'!
couldMatch: aBlossom with: comparator
	^ aBlossom isDestruction not! !

!DEAbstractNode methodsFor: 'printing' stamp: 'cwp 6/22/2004 14:36'!
printOn: stream 
	stream nextPutAll: self class name.
	self printIdentityOn: stream! !

!DEAbstractNode methodsFor: 'testing' stamp: 'cwp 6/21/2004 18:48'!
isPetal
	^ edges size = 1! !

!DEAbstractNode methodsFor: 'testing' stamp: 'cwp 6/21/2004 18:48'!
isStem
	^ edges size > 1! !

!DEAbstractNode methodsFor: 'accessing' stamp: 'cwp 6/22/2004 14:41'!
removeEdge: anEdge
	edges remove: anEdge! !

DEAbstractNode subclass: #DEDestructionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Graph'!

!DEDestructionNode methodsFor: 'printing' stamp: 'cwp 6/24/2004 10:11'!
printIdentityOn: stream
	stream nextPut: $<.
	stream nextPut: $-.
	stream nextPut: $>! !

!DEDestructionNode methodsFor: 'testing' stamp: 'cwp 6/20/2004 12:53'!
isDestruction
	^ true! !

!DEDestructionNode methodsFor: 'testing' stamp: 'cwp 6/22/2004 14:21'!
couldMatch: aBlossom with: comparator
	^ aBlossom isCreation not! !

Object subclass: #DEOperation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Patches'!

DEOperation subclass: #DEJoin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Patches'!

DEOperation subclass: #DEAttach
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Patches'!

DEOperation subclass: #DEMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Patches'!

DEOperation subclass: #DECopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Patches'!

DEOperation subclass: #DEUpdate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Patches'!

DEOperation subclass: #DEInsert
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Patches'!

DEOperation subclass: #DEPrune
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Patches'!

DEOperation subclass: #DEDelete
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Patches'!

TestResource subclass: #DESourceResource
	instanceVariableNames: 'tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Tests'!

!DESourceResource methodsFor: 'accessing' stamp: 'cwp 6/24/2004 13:00'!
setUp
	tree := DEBogusNodeA name: #alpha label: #first.
	tree
		addLeft: (DEBogusNodeB name: #beta label: #second);
		addRight: (DEBogusNodeA name: #gamma label: #third)! !

!DESourceResource methodsFor: 'accessing' stamp: 'cwp 6/19/2004 22:55'!
tree
	^ tree! !

TestResource subclass: #DETargetResource
	instanceVariableNames: 'tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Tests'!

!DETargetResource methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2004 23:06'!
tree
	^ tree! !

!DETargetResource methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2004 23:06'!
setUp
	tree _ DESourceResource current tree copy.
	! !

TestCase subclass: #DEBipartiteGraphTest
	instanceVariableNames: 'graph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Tests'!

!DEBipartiteGraphTest methodsFor: 'testing' stamp: 'cwp 6/22/2004 17:02'!
testEdgeValidity
	self assert: self edges size = 11.
! !

!DEBipartiteGraphTest methodsFor: 'testing' stamp: 'cwp 6/24/2004 17:02'!
setUp
	| tree |
	tree := DESourceResource current tree.
	graph := DEBipartiteGraph 
				source: tree
				target: tree
				grammar: (DEBogusGrammar comparator: [:a :b | a class == b class])! !

!DEBipartiteGraphTest methodsFor: 'accessing' stamp: 'cwp 6/22/2004 17:03'!
edges
	^ graph edges! !

!DEBipartiteGraphTest methodsFor: 'testing' stamp: 'cwp 6/22/2004 17:01'!
testDestructionBlossom
	self assert: (self edges select: [:ea | ea target isDestruction]) size = 3! !

!DEBipartiteGraphTest methodsFor: 'testing' stamp: 'cwp 6/22/2004 17:01'!
testCreationBlossom
	self assert: (self edges select: [:ea | ea source isCreation]) size = 3! !

TestCase subclass: #DEAnnotationTest
	instanceVariableNames: 'graph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiffEng-Tests'!

!DEAnnotationTest methodsFor: 'asserting' stamp: 'cwp 6/26/2004 18:57'!
edgesFrom: aSymbol 
	| source |
	source := (graph edges 
				detect: [:ea | ea source hasNode and: [ea source node name = aSymbol]]
				ifNone: [self signalFailure: 'no source nodes named ' , aSymbol]) source.
	^source edges ! !

!DEAnnotationTest methodsFor: 'asserting' stamp: 'cwp 6/29/2004 14:12'!
opsFromEdges: edges
	^ edges asBag collect: [:ea | ea annotation op]! !

!DEAnnotationTest methodsFor: 'asserting' stamp: 'cwp 6/26/2004 19:00'!
opsTo: aSymbol 
	^ self opsFromEdges: (self edgesTo: aSymbol) ! !

!DEAnnotationTest methodsFor: 'asserting' stamp: 'cwp 6/26/2004 19:00'!
opsFrom: aSymbol	
	^ self opsFromEdges: (self edgesFrom: aSymbol)! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/26/2004 15:40'!
testAttachLeaf
	self source: #(a) target: #(a (b)).
	self assertEdgesTo: #b are: #(insert).! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/24/2004 10:40'!
testCopyWithMove
	self source: #(a ((b (c)) d)) target: #(a ((b) (d (c c)))).
	self assertEdgesFrom: #c are: #(move copy).! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/22/2004 17:33'!
testSimpleMove
	self source: #(a ((b (c)) (d))) target: #(a ((b) (d (c)))).
	self assertEdgesTo: #c are: #(move)! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/26/2004 15:41'!
testPruneTwig
	self source: #(a ((b (c)))) target:  #(a).
	self assertEdgesFrom: #b are: #(delete).
	self assertEdgesFrom: #c are: #(delete).! !

!DEAnnotationTest methodsFor: 'asserting' stamp: 'cwp 6/26/2004 21:19'!
assertEdgesTo: aSymbol are: anArray 
	| ops |
	ops := self opsTo: aSymbol.
	self assert: ops = anArray asBag! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/26/2004 19:07'!
testMoveAndCopy
	self source:  #(a ((b (c)) d)) target: #(a (b (d (c)) (d (c)))).
	self assertEdgesFrom: #d are: #(noOp copy).
	self assertEdgesFrom: #c are: #(move noOp).
	self assertEdgesAt: #d with: #copy dependOn: #c with: #move! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/26/2004 17:54'!
testSimpleCopy
	self source: #(a (b)) target: #(a (b b)). 
	self assertEdgesFrom: #b are: #(noOp copy).! !

!DEAnnotationTest methodsFor: 'graph building' stamp: 'cwp 6/24/2004 17:01'!
source: sexpr1 target: sexpr2
	| sTree tTree |
	sTree _ self treeFromSExpression: sexpr1.
	tTree _ self treeFromSExpression: sexpr2.
	graph _ DEBipartiteGraph 
				source: sTree 
				target: tTree 
				grammar: (DEBogusGrammar comparator: [:a :b | a name = b name]).
	self prune.
	DEAnnotator annotate: graph! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/28/2004 16:25'!
testJoinAndMove
	self source: #(a (b (d (c)) (d (c)))) target: #(a ((b (c)) d)).
	self assertEdgesTo: #d are: #(noOp join).
	self assertEdgesTo: #c are: #(move noOp).
	self assertEdgesAt: #c with: #move dependOn: #d with: #join! !

!DEAnnotationTest methodsFor: 'asserting' stamp: 'cwp 6/26/2004 18:59'!
edgesTo: aSymbol 
	| blossom |
	blossom := (graph edges 
				detect: [:ea | ea target hasNode and: [ea target node name = aSymbol]]
				ifNone: [self signalFailure: 'no target nodes named ' , aSymbol]) target.
	^blossom edges ! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/28/2004 16:26'!
testTwoLevelJoin
	self source:  #(a ((b (c c)) (b (c c)))) target: #(a ((b (c)))).
	self assertEdgesTo: #b are: #(join noOp).
	self assertEdgesTo: #c are: #(join noOp noOp noOp).
	self assertEdgesAt: #c with: #join dependOn: #b with: #join! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/22/2004 16:58'!
testSimpleJoin
	self source:  #(a ((b) (b))) target:  #(a (b)).
	self assertEdgesTo: #b are: #(noOp join).! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/26/2004 15:40'!
testAttachTwig
	self source: #(a) target: #(a ((b (c)))).
	self assertEdgesTo: #b are: #(insert).
	self assertEdgesTo: #c are: #(insert).! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/22/2004 17:06'!
testJoinWithMove
	self source: #(a ((b) (d (c c)))) target: #(a ((b (c)))). 
	self assertEdgesTo: #c are: #(move join).! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/26/2004 15:41'!
testPruneLeaf
	self source: #(a (b)) target: #(a).
	self assertEdgesFrom: #b are: #(delete).! !

!DEAnnotationTest methodsFor: 'asserting' stamp: 'cwp 6/29/2004 14:12'!
assertEdgesAt: dName with: dOp dependOn: iName with: iOp
	| edges deps |
	edges _ self edgesFrom: dName.
	edges addAll: (self edgesTo: dName).
	edges _ edges select: [:ea | ea annotation operation = dOp].
	edges do: [:ea | 
				deps _ ea annotation dependencies 
						collect: [:dep | {dep source node name. dep annotation op}].
				self assert: (deps includes: {iName. iOp})]! !

!DEAnnotationTest methodsFor: 'graph building' stamp: 'cwp 6/22/2004 15:56'!
prune
	graph edges 
		removeAllSuchThat: [:ea | ea pruneIfTrue: ((ea isCreation and: [ea target isStem])
								  or: [ea isDestruction and: [ea source isStem]])].
	
	graph edges
		do: [:ea | ea source isStem ifTrue: [self assert: ea target isPetal].
				  ea target isStem ifTrue: [self assert: ea source isPetal]]
	! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/28/2004 13:01'!
testTwoLevelCopy
	self source: #(a ((b (c)))) target: #(a ((b (c c)) (b (c c)))). 
	self assertEdgesFrom: #b are: #(copy noOp).
	self assertEdgesFrom: #c are: #(copy noOp noOp noOp).
	self assertEdgesAt: #b with: #copy dependOn: #c with: #copy! !

!DEAnnotationTest methodsFor: 'tests' stamp: 'cwp 6/26/2004 17:54'!
testIndirectCopy
	self source: #(a (b)) target: #(a ((b) (c (b)))). 
	self assertEdgesFrom: #b are: #(noOp copy).! !

!DEAnnotationTest methodsFor: 'graph building' stamp: 'cwp 6/24/2004 13:00'!
treeFromSExpression: sexpr 
	| node |
	sexpr isSymbol ifTrue: [^DEBogusNodeA name: sexpr].
	sexpr size = 1 ifTrue: [^DEBogusNodeA name: sexpr first].
	sexpr size = 2 
		ifTrue: 
			[node := DEBogusNodeA name: sexpr first.
			sexpr second do: [:ea | node addLeft: (self treeFromSExpression: ea)].
			^node].
	sexpr size = 3 
		ifTrue: 
			[node := DEBogusNodeA name: sexpr first.
			sexpr second do: [:ea | node addLeft: (self treeFromSExpression: ea)].
			sexpr third do: [:ea | node addRight: (self treeFromSExpression: ea)].
			^node].
	sexpr size = 4 
		ifTrue: 
			[node := DEBogusNodeA name: sexpr first.
			node value: sexpr second.
			sexpr third do: [:ea | node addLeft: (self treeFromSExpression: ea)].
			sexpr fourth do: [:ea | node addRight: (self treeFromSExpression: ea)].
			^node]! !

!DEAnnotationTest methodsFor: 'asserting' stamp: 'cwp 6/26/2004 21:19'!
assertEdgesFrom: aSymbol are: anArray 
	| ops |
	ops := self opsFrom: aSymbol.
	self assert: ops = anArray asBag! !

!Collection methodsFor: '*diffeng-enumerating' stamp: 'cwp 6/20/2004 00:37'!
with: aCollection pairsDo: aBlock 
	^ self do: [:own | aCollection do: [:other | aBlock value: own value: other]]! !

!Collection methodsFor: '*diffeng-enumerating' stamp: 'cwp 6/23/2004 09:39'!
partition: aBlock
	| partitions key |
	partitions _ Dictionary new.
	self do: [:ea | key _ aBlock value: ea.
			(partitions at: key ifAbsentPut: [self class new]) add: ea].
	^ partitions values! !
